

const swiperinoDebugFuncs = () => {
	document.addEventListener('keydown', (e) => {
	  console.log("keydown e",e);
	  console.log("keydown e.keyCode",e.keyCode);
	});

	document.addEventListener('keyup', (e) => {
	  console.log("keyup e",e);
	  console.log("keyup e.keyCode",e.keyCode);
	});

	document.addEventListener('keypress', (e) => {
	  console.log("keypress e",e);
	  console.log("keypress e.keyCode",e.keyCode);
	});

	document.addEventListener('click', (e) => {
	  console.log("click e",e);
	  console.log("click e.keyCode",e.keyCode);
	});
}

let gSwiperinoMax = false;
let gSwiperinoLoadTime = gSwiperinoMax?250:300;

const swiperinoLoad = () => {
	let swiperinoVersion = "4.3.3";	
	// let localEnv = "local";
	let localEnv = "prod";
	// let localEnv = "dev";
	// let useSmartSwipe = false;
	let disableActualSwipe = false;
	let verbose = false;
	let mobileVersion = false;
	let swiperinoMax = gSwiperinoMax;
	let appName = swiperinoMax?"Swiperino Max":"Swiperino";


	var s = document.createElement('script');
	s.src = chrome.runtime.getURL('geo.js');
	s.onload = function() {
		// console.log("script loaded");
		this.remove();
	};
	(document.head || document.documentElement).appendChild(s);


	const KeyEnum = {
		arrowLeft: 		{ key: "ArrowLeft", 	keyCode: 37, code: 37 },
    arrowUp: 			{ key: "ArrowUp", 		keyCode: 38, code: 38 },
    arrowRight: 	{ key: "ArrowRight", 	keyCode: 39, code: 39 },
    arrowDown: 		{ key: "ArrowDown", 	keyCode: 40, code: 40 },
    numberOne: 		{ key: "1", 					keyCode: 49, code: 49 },
    numberTwo: 		{ key: "2", 					keyCode: 50, code: 50 },
    escape: 			{ key: "Escape", 			keyCode: 27, code: 27 },
	}

	const KeyUpElementEnum = {
		Badoo: document.querySelector(".encounters-card"),
		Bumble: window,
		Tinder: window.body,
	}
	

	console.log("Swiperino v",swiperinoVersion)

	// let htmlLang2 = document.documentElement;

	let htmlLang = $('html').attr("lang");
	htmlLang = htmlLang.substring(0, 2);


	// Determine language here
	let availableDisplayLangs = [
		"en",
		"ja",
		"ko",
		"de",
		"ru",

		"pt",
		"pl",
		"fr",
		"es",
		"it",
	];

	let displayLang = "en";
	if(availableDisplayLangs.indexOf(displayLang) !== -1){
		displayLang = htmlLang;
	}
	const dl = displayLang;

	const domainSub = (displayLang !== "en" && availableDisplayLangs.indexOf(displayLang) !== -1)? displayLang+"." :"";

	let swiperinoDomain = "https://"+domainSub+"swiperino.com";
	let swiperinoApiDomain = "https://api.swiperino.com";
	if(localEnv === "local"){
		swiperinoDomain = "http://localhost:8888";
		swiperinoApiDomain = "http://localhost:3060";
	}else if(localEnv === "dev"){
		swiperinoDomain = "https://testswiperino.com";
		swiperinoApiDomain = "https://api.testswiperino.com";
	}else{
		verbose = false;
		disableActualSwipe = false;
	}
	
	if(disableActualSwipe){
		let msg = "Swiperino: DEBUG/TEST MODE. ActualSwipe disabled. ";
		alert(msg)
		console.log(msg);
	}

	const appTypes = {
		Tinder: 1,
		Bumble: 2,
		Badoo: 3,		
	}	

	const appTypeConfigs = {
		Tinder: {
			name: "Tinder",
			class: "tinder",
			keyUpElement: KeyUpElementEnum.Tinder,
			refreshDomain: "",
			likeStrings: [],
			dislikeStrings: [],
			itsAMatchOne: '',
			itsAMatchTwo: '',
			backToTinderOne: '',
			backToTinderTwo: '',
			autoMessageButton: '',

			chatBox: '',
			chatBoxes: '',
			chatFirstDiv: '',
			chatFirstDivText: '',
			chatFirstDivTime: '',
			chatName: '',
			chatProfile: '',

		},
		Bumble: {
			name: "Bumble",
			class: "bumble",
			keyUpElement: KeyUpElementEnum.Bumble,
			refreshDomain: "",
			likeStrings: [],
			dislikeStrings: [],	

			chatBox: '',
			chatBoxes: '',
			chatFirstDateClass: '',
			chatFirstMessageClass: '',
			chatFirstMessageOutClass: '',
			chatName: '',
			chatProfile: '',
		},
		Badoo: {
			name: "Badoo",
			class: "badoo",
			keyUpElement: KeyUpElementEnum.Badoo,
			refreshDomain: "",
			likeStrings: [],
			dislikeStrings: [],
		},
	}

	const tinderLangs = {
		"en":{
			itsAMatch: 'likes you too',
			likesYouTooOne: ' likes you too!',
			likesYouTooTwo: '',
			backToTinder: 'Back to Tinder',
			plus: 'Get Tinder Plus',
			upgradeLike: 'Upgrade Your Like!',
		},
		"en-US":{
			itsAMatch: 'likes you too',
			likesYouTooOne: ' likes you too!',
			likesYouTooTwo: '',
			backToTinder: 'Back to Tinder',
			plus: 'Get Tinder Plus',
			upgradeLike: 'Upgrade Your Like!',
		},
		"en-GB":{
			itsAMatch: 'likes you too',
			likesYouTooOne: ' likes you too!',
			likesYouTooTwo: '',
			backToTinder: 'Back to Tinder',
			plus: 'Get Tinder Plus',
			upgradeLike: 'Upgrade Your Like!',
		},
		"en-AU":{
			itsAMatch: 'likes you too',
			likesYouTooOne: ' likes you too!',
			likesYouTooTwo: '',
			backToTinder: 'Back to Tinder',
			plus: 'Get Tinder Plus',
			upgradeLike: 'Upgrade Your Like!',
		},
		"de":{
			itsAMatch: 'mag dich auch',
			likesYouTooOne: ' mag dich auch!',
			likesYouTooTwo: '',
			backToTinder: 'Zurück zu Tinder',
			plus: 'Hol dir Tinder Plus',
			upgradeLike: 'Mein Like upgraden!',
		},
		"ja":{
			itsAMatch: 'もあなたを気に入りました',
			likesYouTooOne: 'もあなたを気に入りました！',
			likesYouTooTwo: '',
			backToTinder: 'Tinder に戻る',
			plus: 'Tinder Plus',
			upgradeLike: 'Likeをアップグレードしよう！',
		},
		"ko":{
			itsAMatch: '님도 회원님을 좋아해요',
			likesYouTooOne: '님도 회원님을 좋아해요!',
			likesYouTooTwo: '',
			backToTinder: 'Tinder로 돌아가기',
			plus: 'Tinder Plus',
			upgradeLike: '기능을 업그레이드하세요!',
		},
		"ru":{
			itsAMatch: 'тоже лайкнул(а) вас',
			likesYouTooOne: ' тоже лайкнул(а) вас!',
			likesYouTooTwo: '',
			backToTinder: 'Назад к Tinder',
			plus: 'Попробуйте Tinder Плюс',
			upgradeLike: 'Прокачай свои лайки',
		},
		"fr":{
			itsAMatch: 'vous aime bien aussi',
			likesYouTooOne: ' vous aime bien aussi.*',
			likesYouTooTwo: '',
			backToTinder: 'Revenir à Tinder',
			plus: 'Tinder Plus',
			upgradeLike: 'Likez comme jamais',
		},
		"fr-CA":{
			itsAMatch: 'aime aussi',
			likesYouTooOne: ' t*aime aussi!',
			likesYouTooTwo: '',
			backToTinder: 'Revenir à Tinder',
			plus: 'Tinder Plus',
			upgradeLike: 'Surclasse ton J\'aime!',
		},
		"es":{
			itsAMatch: 'También le gustas a',
			likesYouTooOne: '¡También le gustas a !',
			likesYouTooTwo: '!',
			backToTinder: 'Regresar a Tinder',
			plus: 'Obtén Tinder Plus®',
			upgradeLike: '¡Lleva tus Likes al siguiente nivel!',
		},
		"es-AR":{
			itsAMatch: 'También le gustás a',
			likesYouTooOne: '¡También le gustás a ',
			likesYouTooTwo: '!',
			backToTinder: 'Volver a Tinder',
			plus: 'Pasate a Tinder Plus',
			upgradeLike: '¡Lleva tus Likes al siguiente nivel!',
		},
		"es-ES":{
			itsAMatch: 'Tú también le gustas a',
			likesYouTooOne: '¡Tú también le gustas a ',
			likesYouTooTwo: '!',
			backToTinder: 'Volver a Tinder',
			plus: 'Tinder Plus',
			upgradeLike: '¡Lleva tus Likes al siguiente nivel!',
		},
		"it":{
			itsAMatch: 'ha espresso interesse per te',
			likesYouTooOne: 'Anche ',
			likesYouTooTwo: ' ha espresso interesse per te!',
			backToTinder: 'Torna su Tinder',
			plus: 'Tinder Plus',
			upgradeLike: 'Potenzia i tuoi Like!',
		},
		"pt":{
			itsAMatch: 'curtiu você também',
			likesYouTooOne: ' curtiu você também!',
			likesYouTooTwo: '',
			backToTinder: 'Voltar para o Tinder',
			plus: 'Tinder Plus',
			upgradeLike: 'Fazer um upgrade de curtidas!',
		},
		"pt-PT":{
			itsAMatch: 'também gosta de si!',
			likesYouTooOne: ' também gosta de si!',
			likesYouTooTwo: '',
			backToTinder: 'Voltar ao Tinder',
			plus: 'Tinder Plus',
			upgradeLike: 'Fazer um upgrade de curtidas!',
		},
		"pl":{
			itsAMatch: 'odwzajemnił Twoje polubienie!',
			likesYouTooOne: 'Użytkownik ',
			likesYouTooTwo: ' odwzajemnił Twoje polubienie!',
			backToTinder: 'Wróć do Tindera',
			plus: 'Tinder Plus',
			upgradeLike: 'Ulepsz swoje polubienia!',
		},
	}	

	let activeLang = tinderLangs.en;

	let appType = appTypes.Tinder;
	let appTypeConfig = appTypeConfigs.Tinder;

	let askForSwiperinoMaxClass = "";
	let askForSwiperinoMaxBool = false;
	if(window.location.hostname.includes("bumble.com")){
		appType = appTypes.Bumble;
		appTypeConfig = appTypeConfigs.Bumble;
	}else if(window.location.hostname.includes("badoo.com")){
		appType = appTypes.Badoo;
		appTypeConfig = appTypeConfigs.Badoo;
	}

	// if(appType === appTypes.Badoo || appType === appTypes.Bumble){
		// askForSwiperinoMaxClass = "show-need-swiperino-max";
		// askForSwiperinoMaxBool = true;
	// }

	// var likeButtonStrings = appTypeConfig.likeStrings;
	// var dislikeButtonStrings = appTypeConfig.dislikeStrings;

	const sZuser = {};

	let signedIn = false;

	const minSwipeSpeed = 350;
	const maxSwipeSpeed = 25000;
	const initSwipeSpeed = 750;
	var swipeSpeed = initSwipeSpeed;

	const minSwipePercentage = 0;
	const maxSwipePercentage = 100;
	const initSwipePercentage = 97;
	var swipePercentage = initSwipePercentage;

	var ageRangeChecked = localStorage.getItem("ageRangeChecked") !== null && localStorage.getItem("ageRangeChecked") === "true"?true:false;
	var ageRangeMin = localStorage.getItem("ageRangeMin") !== null && parseInt(localStorage.getItem("ageRangeMin")) >= 18?parseInt(localStorage.getItem("ageRangeMin")):18;
	var ageRangeMax = localStorage.getItem("ageRangeMax") !== null && parseInt(localStorage.getItem("ageRangeMax")) <= 65?parseInt(localStorage.getItem("ageRangeMax")):65;

	var maxDistanceChecked = localStorage.getItem("maxDistanceChecked") !== null && localStorage.getItem("maxDistanceChecked") === "true"?true:false;
	const minDistNumber = 1;
	const maxDistNumber = 500;
	var maxDistanceRange = localStorage.getItem("maxDistanceRange") !== null && parseInt(localStorage.getItem("maxDistanceRange")) >= 1?parseInt(localStorage.getItem("maxDistanceRange")):25;


	let ageRangeDefaultMinNumber = 18;
	let ageRangeDefaultMaxNumber = 65;
	let ageRangeMinNumber = localStorage.getItem("ageRangeMinNumber") && parseInt(localStorage.getItem("ageRangeMinNumber")) >= 1?parseInt(localStorage.getItem("ageRangeMinNumber")):18;
	let ageRangeMaxNumber = localStorage.getItem("ageRangeMaxNumber") && parseInt(localStorage.getItem("ageRangeMaxNumber")) >= 1?parseInt(localStorage.getItem("ageRangeMaxNumber")):25;
	var unlimitedSwipeNumber = true;
	const minSwipeNumber = 25;
	const maxSwipeNumber = 2500;
	const initSwipeNumber = randomIntFromInterval(250,1500);
	var swipePercentage = swipeSpeed;
	const swipeNumberToggledMessage = zTran(dl,'swipeNumberThresholdTrigger',{swipeNumber:zTran(dl,'swipeNumber')});

	const outOfSwiperinoLikesMessage = zTran(dl,'outOfSwiperinoLikesMessage');
	const cannotFindButtonsText = zTran(dl,'cannotFindButtonsText',{
		stop: zTran(dl,'stop'),
		email: "mail@swiperino.com",
		appTypeName: appTypeConfig.name,
	});

	let routines = [];
	let chatTokens = 0;

	const googleMapsApiKey = "AIzaSyD-zRK44f30rVHr--PezefOyOZYedoOk0U";

	let swipeSpeedBuffer = 25;
	let updatePercentage = 5;

	const premiumAccess = ["premium","admin"];

	// let logoIcon = '<svg version="1.1" id="Capa_2" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 1080 1080" style="enable-background:new 0 0 1080 1080;" xml:space="preserve">'+
	// '<g id="XMLID_159_">'+
	// '<path id="XMLID_160_" fill:"#AD014E"; d="M313.5,719.8c0,0,4.5-86.5,89-104c0,0,51.5-9,113,20c0,0,51.5,26,30-25c0,0,70.5,20,79,61,c0,0,8,35.8-5.7,48c0,0-41.3,49.2-169,1.5c0,0-51-17.3-103.3-9.3C346.5,712,323.5,716.3,313.5,719.8z"/>'+
	// '<path id="XMLID_161_" fill:"#AD014E"; d="M635,726.3c0,0,48-47.5-28-111.5c0,0-9-13-150.5-71c0,0-57.5-21-74.5-71.5,c-6.4-18.9-5.9-38.9-2.7-56.5c5.8-32.3,22.8-61.7,47.8-83c6.5-5.5,12.5-9.5,16.4-9.5c0,0-31.5,44,4.5,82c0,0,34,38,79.5,52,l90.2,33.6c22.1,8.2,42.2,21.3,58.2,38.7c11.8,12.8,23,29.4,28.6,49.7c15,54-13,100.5-13,100.5S672,710.3,635,726.3z"/>'+
	// '<path id="XMLID_162_" fill:"#AD014E"; d="M538.5,437.8c0,0-71-9.5-83.5-77c0,0-8-38.5,40.3-50.5c0,0,56.8-11.5,94.3,3.5,c0,0,70,31,127.5,27c0,0,52-6,52-12.5c0,0,6.3,41.4-36.7,79.8c-16.1,14.4-36.3,23.4-57.8,25.4c-22.2,2.1-54.2,0.1-93.4-16.2,c0,0-21.1-10.9-40.6-9.1c-4.4,0.4-7.9,3.5-8.9,7.8C530.3,421.3,533.2,429.1,538.5,437.8z"/>'+
	// '</g></svg>';
	let logoIcon = '<img src="https://swiperino.com/css/favicon.png">';

	let mobileVersionClass = (mobileVersion) ? "mobile-version" : "";

	let locations = [
		{ name:"Amsterdam",			lat: "52.3546448", long:   "4.8337496"},
		{ name:"Athens",				lat: "37.9840689", long:   "23.7252257"},
		{ name:"Auckland",			lat:"-36.8509739", long: "174.7644341"},
		{ name:"Barcelona",			lat: "41.3947687", long:   "2.0785567"},
		{ name:"Berlin",				lat: "52.5143938", long:  "13.3845053"},
		{ name:"Buenos Aires",	lat:"-34.6104504", long: "-58.3921105"},
		{ name:"Copenhagen",		lat: "55.6849577", long:  "12.5796781"},
		{ name:"Dublin",				lat: "53.3502879", long:  "-6.2711230"},
		{ name:"Helsinki",			lat: "60.1689143", long:  "24.9362537"},
		{ name:"Kiev",					lat: "50.4426002", long:  "30.5124436"},
		{ name:"London",				lat: "51.5075314", long:  "-0.1340836"},
		{ name:"Los Angeles",		lat: "34.0098526", long:"-118.3988003"},
		{ name:"New York",			lat: "40.7643354", long: "-73.9796034"},
		{ name:"Melbourne",			lat:"-37.8347279", long: "145.0118359"},
		{ name:"Miami",					lat: "25.7823907", long: "-80.2996699"},
		{ name:"Moscow",				lat: "55.7587881", long: 	"37.6181093"},
		{ name:"Oslo",					lat: "59.9220646", long:  "10.7452177"},
		{ name:"Paris",					lat: "48.8607948", long:   "2.3501167"},
		{ name:"Portland",			lat: "45.5236047", long:"-122.6458688"},
		{ name:"Reykjavík",			lat: "64.1309985", long: "-21.8931523"},
		{ name:"Rome",					lat: "41.8872824", long:  "12.4902876"},
		{ name:"Seattle",				lat: "47.5965221", long:"-122.3307979"},
		{ name:"Stockholm",			lat: "59.3308964", long:  "18.0667186"},
		{ name:"Sydney",				lat:"-33.8939811", long: "151.1881888"},
		{ name:"Tokyo",					lat: "35.6611379", long: "139.7043857"},
		{ name:"Toronto",				lat: "43.7181552", long: "-79.5184832"},
		{ name:"Vancouver",			lat: "49.2577142", long:"-123.1941149"},
		{ name:"Warsaw",				lat: "52.240529",  long:  "21.0066715"},
		{ name:"Wellington",		lat:"-41.2895858", long: "174.7690461"},
		{ name:"Zürich",				lat: "47.3761310", long:   "8.5255437"},
	]; 

	var locationsOptions = "";
	for (var i = 0; i < locations.length; i++) {
		locationsOptions += '<option value="'+i+'">'+locations[i].name+'</option>';		
	}

	// let swiperinoMaxUrl = "https://chrome.google.com/webstore/detail/swiperino-max/dkpjdenhokmnbkpmdgpkoognocgdhlpk";

	let foo = localStorage.getItem("swiperinoIsVisible");
	let swiperinoIsVisible = (localStorage.getItem("swiperinoIsVisible") !== null && localStorage.getItem("swiperinoIsVisible") === "false")?false:true;
	let panel = ""+
	'<div class="swiperino-panel mobile-hide '+mobileVersionClass+' '+appTypeConfig.class+' '+askForSwiperinoMaxClass+'">'+

		'<a class="swiperino-top-logo" target="_blank" href="'+swiperinoDomain+'">'+logoIcon+'</a>'+
		'<div class="swiperino-content">'+

			// '<div class="swiperino-max-required" style="display:none;">'+
			// 	'<h3>Need Swiperino Max for Bumble & Badoo</h3>'+
			// 	'<p>No worries, its free and your Swiperino api-key will work with it.</p>'+
			// 	'<p>In order for Swiperino to work on Bumble & Badoo Swiperino needs extra permissions which is why we\'ve created a separate extension. </p>'+
			// 	'<a href="'+swiperinoMaxUrl+'" target="_blank">Get Swiperino Max</a>'+
			// '</div>'+

 			'<div class="swiperino-provide-api-key">'+
	 			'<p>'+
	 				zTran(dl,'swiperinoAdded1')+
	 			'</p>'+
 				'<p>'+
 					zTran(dl,'swiperinoAdded2',{link:'<a href="'+swiperinoDomain+'">Swiperino</a>'})+
				'</p>'+
				'<p>'+
					zTran(dl,'swiperinoAdded3',{link:'<a href="'+swiperinoDomain+'/my-account">'+zTran(dl,'myAccountText')+'</a>'})+
				'</p>'+
				'<form class="swiperino-api-key">'+
					'<div class="swiperino-api-key-loading" style="display:none;"><div><span></span></div></div>'+
					'<input type="text" class="api-key-value" placeHolder="'+zTran(dl,'apiKey')+'">'+
					'<input type="submit" value="'+zTran(dl,'verifyApiKey')+'">'+
				'</form>'+
				'<div class="api-key-errors" style="display:none;"></div>'+
			'</div>'+

			'<div class="swiperino-api-key-provided" style="display:none;">'+
				'<div class="swiperino-notifs" style="display:none;">'+
					'<div class="close">x</div>'+
					'<p class="text"></p>'+
				'</div>'+
				'<div class="swiperino-account-info">'+
					'<p>'+zTran(dl,'accountType')+'</p>'+
					'<h2 class="swiperino-account-type"><span>loading...</span><a class="upgrade" target="_blank" href="'+swiperinoDomain+'/pricing">'+zTran(dl,'upgrade')+'</a></h2>'+
					'<p>'+zTran(dl,'apiKey')+'</p>'+
					'<input type="text" class="auth-api-key" id="swiperino-api-key-input" readonly/>'+
				'</div>'+
				'<div class="swiperino-controls">'+
					// '<label>'+zTran(dl,'autoMessage')+'</label>'+

					'<div class="chatgpt-header">'+
						'<div>Tokens: <span class="chatgpt-token-amount">0</span></div>'+
						'<a target="_blank" href="'+swiperinoDomain+'/chat">Get More</a>'+
					'</div>'+ 
					'<button class="chatgpt-header-button">'+
						'<div class="text">Reply with ChatGPT</div>'+
						'<div class="loading-wheel"><div></div><span></span></div>'+
					'</button>'+ 
					'<a class="chat-settings" target="_blank" href="'+swiperinoDomain+'/my-account#chat">Tell ChatGPT about yourself</a>'+
					'<div class="swiperino-auto-message off">'+
						'<span class="on">'+zTran(dl,'disableAutoMessage')+'</span>'+
	 					'<span class="off">'+zTran(dl,'enableAutoMessage')+'</span>'+
	 				'</div>'+
					'<div class="swiperino-current-auto-message" style="display:none;">'+
						'<div class="message"></div>'+
						'<a target="_blank" href="'+swiperinoDomain+'/my-account#auto-message">'+zTran(dl,'editAutoMessage')+'</a>'+
					'</div>'+
					
					'<button class="swiperino-custom-location">'+zTran(dl,'setCustomLocation')+'</button>'+ 

					'<div class="swiperino-custom-location-panel">'+
						'<div class="swiperino-custom-location-panel-grayscreen"></div>'+
						'<div class="swiperino-custom-location-panel-content">'+
							// '<div class="banner">This feature may not be working for some users, we\'re looking into a fix currently. Until then, you can change your location via google chrome\'s inspector->sensor at the right. We\'ll be uploading a video shortly on our youtube channel to show how this is done.</div>'+
							'<div class="inner-content">'+
								'<h2>Swiperino - '+zTran(dl,'customGeolocation')+'</h2>'+
								'<h3>'+zTran(dl,'customGeolocationHeader',{appName:appTypeConfig.name})+'</h3>'+
								'<button class="swiperino-clear-custom-coords">'+zTran(dl,'clearCustomCords')+'</button>'+
								'<div id="swiperino-map">loading...</div>'+
								'<p>'+zTran(dl,'changeCords',{appName:appTypeConfig.name})+'</p>'+
								'<p>'+zTran(dl,'insertCords',{link:'<a class="upgrade" target="_blank" href="'+swiperinoDomain+'/how-to-use#change-location">'+zTran(dl,'changeLocation')+'</a>'})+'</p>'+
								'<form id="swiperino-map-form">'+
									'<div class="spacer">'+
										'<label>'+zTran(dl,'selectACity')+'</label>'+
										'<select id="swiperino-locations-select">'+	
											locationsOptions+
										'</select>'+
									'</div>'+
									'<div class="spacer">'+
										'<label>'+zTran(dl,'latitude')+'</label>'+
										'<input id="swiperino-locations-lat" type="text" name="lat">'+
									'</div>'+
									'<div class="spacer">'+
										'<label>'+zTran(dl,'longitude')+'</label>'+
										'<input id="swiperino-locations-long" type="text" name="long">'+
									'</div>'+
									'<div class="spacer">'+
										'<label>w</label>'+
										'<input type="submit" value="'+zTran(dl,'setNewCords')+'">'+
									'</div>'+
								'</form>'+
							'</div>'+
						'</div>'+
					'</div>'+  

					'<div class="form-label">'+
						'<label>'+zTran(dl,'swipeSpeedText')+'</label>'+
						'<div class="manual-input">'+
							'<input id="swipe-speed-text" type="number" min="'+minSwipeSpeed+'" max="'+maxSwipeSpeed+'" placeholder="min:'+minSwipeSpeed+',max:'+maxSwipeSpeed+'" value="'+initSwipeSpeed+'">'+
						'</div>'+
						'<div class="slider-input">'+
							'<input id="swipe-speed-slider" min="'+minSwipeSpeed+'" max="'+maxSwipeSpeed+'" type="range"'+ 
										' value="'+initSwipeSpeed+'" style="direction: rtl;"/>'+
						'</div>'+
	 				'</div>'+

	 				'<div class="form-label">'+
	 					'<label>'+zTran(dl,'rightSwipePercentage')+'</label>'+
	 					'<div class="manual-input">'+
	 						'<input id="swipe-percent-text" type="number" min="'+minSwipePercentage+'" max="'+maxSwipePercentage+'" placeholder="min:'+minSwipePercentage+', max:'+maxSwipePercentage+'" value="'+initSwipePercentage+'">'+
						'</div>'+
	 					'<div class="slider-input">'+
		 					'<input id="swipe-percent-slider" min="'+minSwipePercentage+'" max="'+maxSwipePercentage+'" type="range"'+
		 								' value="'+initSwipePercentage+'"/>'+
						'</div>'+
	 				'</div>'+

	 				'<div class="form-label age-range-div">'+
	 					'<label>Age Range</label>'+
	 					'<label class="range-div-active">'+
	 						'<div>Any</div>'+
	 						'<input id="range-div-active-checkbox" type="checkbox" checked="true">'+
						'</label>'+
	 					'<div class="manual-input">'+
	 						'<div class="input-div"><input id="age-range-min-number" type="number" placeholder="" value="'+ageRangeMinNumber+'"></div>'+
	 						'<div class="spacer">~</div>'+
	 						'<div class="input-div age-range-max-num"><input id="age-range-max-number" type="number" placeholder="" value="'+ageRangeMaxNumber+'"></div>'+
						'</div>'+
	 					'<div class="slider-input">'+
			 				'<div id="age-slider-range"></div>'+
						'</div>'+
	 				'</div>'+

	 				'<div class="form-label max-dist-range-div">'+
	 					'<label>Max Distance</label>'+
	 					'<label class="dist-div-active">'+
	 						'<div>Any</div>'+
	 						'<input id="dist-div-active-checkbox" type="checkbox" checked="true">'+
						'</label>'+
	 					'<div class="manual-input">'+
	 						'<input id="dist-range-number-input" type="number" placeholder="" value="'+maxDistanceRange+'">'+
						'</div>'+
	 					'<div class="slider-input">'+
			 				'<input id="max-dist-range-slider" min="'+minDistNumber+'" max="'+maxDistNumber+'" type="range"'+
		 								' value="'+maxDistanceRange+'"/>'+
						'</div>'+
	 				'</div>'+


	 				'<div class="form-label unlimited-swipe-number-div">'+
	 					'<label>'+zTran(dl,'swipeSession')+'</label>'+
	 					'<label class="unlimited-swipe-number">'+
	 						'<div>'+zTran(dl,'unlimited')+'</div>'+
	 						'<input id="unlimited-swipe-number-checkbox" type="checkbox" checked="true">'+
						'</label>'+
	 					'<div class="manual-input">'+
	 						'<input id="swipe-number-text" type="number" placeholder="" value="'+initSwipeNumber+'">'+
						'</div>'+
	 					'<div class="slider-input">'+
		 					'<input id="swipe-number-slider" min="'+minSwipeNumber+'" max="'+maxSwipeNumber+'" type="range"'+
		 								' value="'+initSwipeNumber+'"/>'+
						'</div>'+
	 				'</div>'+

	 				'<div class="swiperino-routine off">'+
	 					'<span class="on">'+zTran(dl,'disableRoutines')+'</span>'+
	 					'<span class="off">'+zTran(dl,'enableRoutines')+'</span>'+
	 				'</div>'+
					'<div class="swiperino-no-routines" style="display:none;">'+
						'<p>'+
							zTran(dl,'noRoutinesFoundText',{link:'<a target="_blank" href="'+swiperinoDomain+'/my-account#routines">swiperino.com/my-account</a>'})+
						'</p>'+
					'</div>'+
	 				'<div class="swiperino-buttons">'+
	 					'<button class="start">'+zTran(dl,'start')+'</button>'+
	 					'<button class="stop">'+zTran(dl,'stop')+'</button>'+
	 				'</div>'+
	 				'<div class="status-box">'+
	 					'<div class="status-current">'+zTran(dl,'status')+': '+zTran(dl,'idle')+'</div>'+
	 					'<div class="status-detail"></div>'+
	 				'</div>'+
	 				'<div class="stats-box">'+
	 					'<div><div>Stats</div></div>'+
	 					'<div class="stats">'+
		 					'<div><div>Right: </div><div class="swiperino-right-swipes">0</div></div>'+
		 					'<div><div>Left: </div><div class="swiperino-left-swipes">0</div></div>'+
	 					'</div>'+
	 					'<div><button type="button" class="swiperino-stat-reset">Reset</button></div>'+
	 				'</div>'+
				'</div>'+
	 		'</div>'+
	 	'</div>'+
	 	'<div class="swiperino-footer">'+
	 		'<a target="_blank" href="'+swiperinoDomain+'" class="swiperino-logo">'+logoIcon+appName+'<span class="swiperino-version">v'+swiperinoVersion+'</span></a>'+
	 		'<div class="swiperino-footer-links">'+
	 			'<a target="_blank" href="'+swiperinoDomain+'/help">'+zTran(dl,'help')+'</a>'+
	 			'<a target="_blank" href="'+swiperinoDomain+'/terms-of-use">'+zTran(dl,'terms')+'</a>'+
	 			'<a target="_blank" href="'+swiperinoDomain+'/privacy-policy">'+zTran(dl,'privacyPolicy')+'</a>'+
	 		'</div>'+
	 	'</div>'+
	'</div>';

	let mobileHeader = ""+
	'<div class="swiperino-mobile-header">'+
		'<div class="buttons">'+
			'<div class="left">'+
				'<button class="menu">Menu</button>'+
			'</div>'+
			'<div class="mid">'+
				'<div class="logo">'+logoIcon+'</div>'+
				'<div class="status-text">Status text</div>'+
			'</div>'+
			'<div class="right">'+
				'<button class="chatgpt-reply">'+
					'ChatGPT Reply'+
					'<div class="loading-wheel"><div></div><span></span></div>'+
				'</button>'+
				'<button class="startStop login">'+
					'<span class="start">'+zTran(dl,'start')+'</span>'+
					'<span class="stop">'+zTran(dl,'stop')+'</span>'+
				'</button>'+
			'</div>'+
		'</div>'+
	'</div>';

	let toggleVisButton = ""+
	'<div class="toggle-swiperino-visibility">'+
		'<div class="show-option">'+
			logoIcon+
			'<div>'+zTran(dl,'show')+'</div>'+
		'</div>'+
		'<div class="start-stop-mini">'+
			'<div>'+zTran(dl,'start')+'</div>'+
		'</div>'+
		'<div class="hide-option">'+zTran(dl,'hide')+'</div>'+
	'</div>';

	if(!($('.swiperino-panel').length)){
		$('.toggle-swiperino-visibility').remove();
		$('.swiperino-mobile-header').remove();
		$('.swiperino-panel').remove();
		$('body').append(panel);
		$('body').append(mobileHeader);
		$('body').append(toggleVisButton);

		// console.log("append swiperino to body");

		if(!swiperinoIsVisible){
			$('body').addClass("hide-swiperino");
		}
		$('body').addClass(appTypeConfig.class);

		if(askForSwiperinoMaxBool){
			$('.swiperino-max-required').show();
			$('.swiperino-provide-api-key').hide();
			$('.swiperino-api-key-provided').hide();
		}

    $( "#age-slider-range" ).slider({
      range: true,
      min: ageRangeDefaultMinNumber,
      max: ageRangeDefaultMaxNumber,
      values: [ ageRangeMinNumber, ageRangeMaxNumber ],
      slide: function( event, ui ) {
      	let one = ui.values[0];
      	let two = ui.values[1];
      	ageRangeMinNumber = one;
      	ageRangeMaxNumber = two;
      	if(parseInt(two) >= 65){
      		if(!$('.age-range-max-num').hasClass("max")){
      			$('.age-range-max-num').addClass("max");
      		}
      	}else{
      		if($('.age-range-max-num').hasClass("max")){
      			$('.age-range-max-num').removeClass("max");
      		}
      	}
      	localStorage.setItem("ageRangeMinNumber",one);
      	localStorage.setItem("ageRangeMaxNumber",two);
      	$('#age-range-min-number').val(one);
      	$('#age-range-max-number').val(two);
      }
    });
    // $( "#amount" ).val( "$" + $( "#slider-range" ).slider( "values", 0 ) +
    //   " - $" + $( "#slider-range" ).slider( "values", 1 ) );

	}




	const lang = $('html').attr("lang");
	let validLang = false;

	for (const [key, value] of Object.entries(tinderLangs)) {
		// console.log("lang",lang);
	  // console.log(`testing-> ${key}: ${value}`);
		if(lang === key){
		  // console.log(`setting-> ${key}: ${value}`);
			activeLang = tinderLangs[key];
			validLang = true;
			break;
		}
	}

	if(!validLang){
		let text = "Swiperino doesn't fully support this language yet. Sorry! Please change the language to English or another supported language and refresh the page. ";
		$('.swiperino-notifs .text').text(text);
		$('.swiperino-notifs').show();
	}
	$('.swiperino-notifs .close').on("click",function(){
		$('.swiperino-notifs').hide();
	});


	$('.toggle-swiperino-visibility .show-option').on("click",function(){
		$('body').removeClass("hide-swiperino");
		localStorage.setItem("swiperinoIsVisible","true");
	});
	$('.toggle-swiperino-visibility .hide-option').on("click",function(){
		$('body').addClass("hide-swiperino");
		localStorage.setItem("swiperinoIsVisible","false");
	});

	$('.toggle-swiperino-visibility .start-stop-mini').on("click",function(){
		let newStatus = (currentStatus === statusEnum.idle)?statusEnum.swiping:statusEnum.idle;
		toggleSwiperino(newStatus);
	});

	$('#swipe-speed-slider').on("input",function(e){
		configSliderUpdated("speed",$(this).val());
	});
	$('#swipe-percent-slider').on("input",function(e){
		configSliderUpdated("percent",$(this).val());
	});
	$('#max-dist-range-slider').on("input",function(e){
		maxDistanceRange = $(this).val();
		localStorage.setItem("maxDistanceRange",$(this).val());
		configSliderUpdated("dist",$(this).val());
	});	
	$('#swipe-number-slider').on("input",function(e){
		configSliderUpdated("number",$(this).val());
	});	

	function configSliderUpdated(slider,val){
		val = parseInt(val)+0;
		if(slider == "speed"){
			$('#swipe-speed-text').val(val);
			updateSwipeSpeed(val);
		}else if(slider == "number"){
			$('#swipe-number-text').val(val);
		}else if(slider === "dist"){
			$('#dist-range-number-input').val(val);
		}else{	
			$('#swipe-percent-text').val(val);
			updateSwipePercentage(val);
		}
	}

	$('#age-range-min-number').on("input",function(e){
		let val2 = $('#age-range-max-number').val();
		ageRangeMaxNumber = val2;
		configInputUpdated("age",$(this).val(),val2);
	});
	$('#age-range-max-number').on("input",function(e){
		let val1 = $('#age-range-min-number').val();
		ageRangeMinNumber = val1
		configInputUpdated("age",val1,$(this).val());
	});

	$('#swipe-speed-text').on("input",function(e){
		configInputUpdated("speed",$(this).val());
	});
	$('#swipe-percent-text').on("input",function(e){
		configInputUpdated("percent",$(this).val());
	});
	$('#dist-range-number-input').on("input",function(e){
		maxDistanceRange = $(this).val();
		configInputUpdated("dist",$(this).val());
	});
	$('#swipe-number-text').on("input",function(e){
		configInputUpdated("number",$(this).val());
	});
	function configInputUpdated(input,val,val2){
		val = parseInt(val)+0;
		if(input == "speed"){
			if(val > maxSwipeSpeed){
				val = maxSwipeSpeed;
			}else if(val < minSwipeSpeed){
				val = minSwipeSpeed;
			}
			$('#swipe-speed-slider').val(val);
			updateSwipeSpeed(val);
		}else if(input == "number"){
			$('#swipe-number-slider').val(val);
		}else if(input === "dist"){
			$('#max-dist-range-slider').val(val);
		}else if(input === "age"){
			$("#age-slider-range").slider('values',0,val);
			$("#age-slider-range").slider('values',1,val2);
		}else{	
			if(val > maxSwipePercentage){
				val = maxSwipePercentage;
			}else if(val < minSwipePercentage){
				val = minSwipePercentage;
			}
			// console.log(val)
			$('#swipe-percent-slider').val(val);
			updateSwipePercentage(val);
		}
	}
	function updateSwipeSpeed(val){
		localStorage.setItem("swiperinoSwipeSpeed",val);
		swipeSpeed = val;
	}
	function updateSwipePercentage(val){
		if(val >= 100){
			alert(zTran(dl,'likeRatioTooHighWarn'));
		}
		localStorage.setItem("swiperinoSwipePercentage",val);
		swipePercentage = val;
	}

	$('#swiperino-locations-select').on("change",function(e){
		let dl = (n) => {
			let r = (Math.random()/75000)-(Math.random()/75000);
			r = Math.round(r * 10000000) / 10000000
			let k = Math.round( (parseFloat(n)+parseFloat(r)) * 10000000) / 10000000;
			return k;
		}
		
		$('#swiperino-locations-lat').val(dl(locations[e.target.value].lat))
		$('#swiperino-locations-long').val(dl(locations[e.target.value].long));
	});


	$('.swiperino-panel .start').on("click",function(){
		startSwiperino();
		toggleRoutines(false);
	});
	$('.swiperino-panel .stop').on("click",function(){
		stopSwiperino();
		toggleRoutines(false);
	});

	$('.swiperino-mobile-header .menu').on("click",function(){
		$('.swiperino-panel').toggleClass("mobile-hide");
	});

	$('.swiperino-mobile-header .startStop').on("click",function(){
		if($(this).hasClass("login")){
			alert(zTran(dl,'addApiKey'));
			return false;
		}

		toggleRoutines(false);
		if($(this).hasClass("stop")){
			stopSwiperino();
		}else{
			startSwiperino();
		}
		$(this).toggleClass("stop");	
	});

	$('.chatgpt-header-button').on("click",function(){
		chatGptFunc();
	});
	$('.chatgpt-reply').on("click",function(){
		chatGptFunc();
	});
	

	let statusEnum = {
		idle: zTran(dl,'idle'),
		swiping: zTran(dl,'swiping'),
	};

	let currentStatus = statusEnum.idle;

	function changeStatusText(msg){
		// console.log("changeStatusText");
		msg = (msg === undefined) ? "" : msg;
		let routinesMsg = (routinesOn) ? zTran(dl,'routines')+" " : "";
		$('.swiperino-panel .status-box .status-current,.swiperino-mobile-header .status-text').text(routinesMsg+zTran(dl,'status')+": "+currentStatus);		
		$('.swiperino-panel .status-box .status-detail').text(msg);

		if(currentStatus == statusEnum.swiping){
			$('.swiperino-mobile-header .startStop').text(zTran(dl,'stop'));
			$('.toggle-swiperino-visibility .start-stop-mini').text(zTran(dl,'stop'));
		}else{
			$('.swiperino-mobile-header .startStop').text(zTran(dl,'start'));
			$('.toggle-swiperino-visibility .start-stop-mini').text(zTran(dl,'start'));
		}
	}

	function stopSwiperino(){
		toggleSwiperino(statusEnum.idle);
		clearSwiperinoRefreshTimeout();
	}	

	function startSwiperino(){
		toggleSwiperino(statusEnum.swiping,true);
		clearSwiperinoRefreshTimeout();
	}

	
	var swiperinoTimeout = 0;
	var breakCheck = 0;
	var breakCheckTime = 0;
	var sleepCheckTime = 0;
	function toggleSwiperino(status, first){
		status = (status === undefined) ? currentStatus : status;

		// console.log("toggleSwiperino",status);

		if(currentStatus != status){
			currentStatus = status;
			changeStatusText();
		}
		if(swiperinoTimeout != 0){
			clearTimeout(swiperinoTimeout);
			swiperinoTimeout = 0;
		}

		if(status == statusEnum.idle){
			// console.log("setting swiperino idle");
			clearBreakCheck();
			updateUser();
			return false;
		}

		if(first){
			setBreakCheck();
		}
		
		let speed = (first !== undefined && first === false) ? (randomIntFromInterval(swipeSpeed*0.85,swipeSpeed*1.2) - 100) : 1;
		
		if(randomIntFromInterval(1,100) >= 98){
			if(randomIntFromInterval(1,100) >= 85){
				changeStatusText("Long Delay Swipe");
				speed = speed*randomIntFromInterval(14,18);
			}else{
				changeStatusText("Short Delay Swipe");
				speed = speed*randomIntFromInterval(4,7);
			}
		}else if(breakCheckTime >= 3000 && randomIntFromInterval(1,100) >= 97){
			speed = randomIntFromInterval(340000,670000);
			changeStatusText("Taking a quick break. "+resumeAt(speed));
			breakCheckTime = -1 * (speed/1000);
		}else if(sleepCheckTime >= 43200 && randomIntFromInterval(1,100) >= 97){//been swiping for 12 hours straight
			speed = randomIntFromInterval(39600000,43200000);
			changeStatusText("Been swiping for 12 hours straight, taking a nap. "+resumeAt(speed));
			breakCheckTime = -1 * (speed/1000);
			sleepCheckTime = -1 * (speed/1000);
		}else{
			changeStatusText();
		}		

		swiperinoTimeout = setTimeout(async function(){
			if(isLikesOutCheck()){
				stopSwiperino();
				changeStatusText(outOfSwiperinoLikesMessage);
				return false;
			}

			if(unlimitedSwipeNumber === false){
				let foo = $('#swipe-number-text').val();
				foo = parseInt(foo);
				if(foo <= 0){
					stopSwiperino();
					changeStatusText(swipeNumberToggledMessage);
					return false;
				}
			}

			await swipe();
			await customSleep(100);
			if(appType === appTypes.Tinder){
				let res = await tinderModalManagerHandle();
			}

			if(appType === appTypes.Bumble){
				let res = await bumbleModalManagerHandle();
			}

			swiperinoTimeout = 0;
			toggleSwiperino(undefined,false);
		},speed);

	}

	function resumeAt(Milliseconds){
		var dateObj = Date.now();
		dateObj += Milliseconds;
		dateObj = new Date(dateObj);
		
		return "Resuming at: "+dateObj.toLocaleTimeString();
	}

	function isLikesOutCheck(){
		if(sZuser.lr === undefined){
			return true;
		}

		if(sZuser.lr <= 0 && premiumAccess.indexOf(sZuser.us) === -1){
			return true;
		}
		return false;
	}


	function clearBreakCheck(){
		breakCheckTime = 0;
		sleepCheckTime = 0;
		if(breakCheck != 0){
			clearInterval(breakCheck);
		}
	}	
	function setBreakCheck(){
		clearBreakCheck();
		breakCheck = setInterval(function(){
			// console.log("breakCheck interval");
			breakCheckTime++;
			sleepCheckTime++;
		},1000);
	}


	var swiperinoRefreshTimeout = 0;
	function clearSwiperinoRefreshTimeout(){
		if(swiperinoRefreshTimeout !== 0){
			// console.log("clearSwiperinoRefreshTimeout");
			clearTimeout(swiperinoRefreshTimeout);
			swiperinoRefreshTimeout = 0;
			localStorage.setItem("swiperinoAutoStartSwipe","0");
		}
	}
	async function swipe(){

		var likeBtn = findLikeButton();
		var dislikeBtn = findDislikeButton();



		if(!likeBtn || !dislikeBtn || likeBtn.length <= 0 || dislikeBtn.length <= 0){

			// if(appType === appTypes.Bumble && window.location.href === appTypeConfig.refreshDomain){
			// 	stopSwiperino();
			// 	toggleRoutines(false);
			// 	$.toast({
			//     text: zTran(dl,'profileNotFound'), // Text that is to be shown in the toast
			//     heading: 'Swiperino', // Optional heading to be shown on the toast
			//     icon: 'info', // Type of toast icon
			//     showHideTransition: 'fade', // fade, slide or plain
			//     allowToastClose: true, // Boolean value true or false
			//     hideAfter: false, // false to make it sticky or number representing the miliseconds as time after which toast needs to be hidden
			//     stack: 5, // false if there should be only one toast at a time or a number representing the maximum number of toasts to be shown at a time
			//     position: 'top-center', // bottom-left or bottom-right or bottom-center or top-left or top-right or top-center or mid-center or an object representing the left, right, top, bottom values
			//     textAlign: 'left',  // Text alignment i.e. left, right or center
			// 	});
			// 	return;
			// }


			stopSwiperino();
			toggleRoutines(false);
			// alert(cannotFindButtonsText);
			$.toast({
			    text: cannotFindButtonsText, // Text that is to be shown in the toast
			    heading: 'Swiperino', // Optional heading to be shown on the toast
			    icon: 'warning', // Type of toast icon
			    showHideTransition: 'fade', // fade, slide or plain
			    allowToastClose: true, // Boolean value true or false
			    hideAfter: false, // false to make it sticky or number representing the miliseconds as time after which toast needs to be hidden
			    stack: 5, // false if there should be only one toast at a time or a number representing the maximum number of toasts to be shown at a time
			    position: 'top-center', // bottom-left or bottom-right or bottom-center or top-left or top-right or top-center or mid-center or an object representing the left, right, top, bottom values
			    textAlign: 'left',  // Text alignment i.e. left, right or center
			});
     

			clearSwiperinoRefreshTimeout();
			localStorage.setItem("swiperinoAutoStartSwipe","1");
			swiperinoRefreshTimeout = setTimeout(() => {
				$(location).attr('href', appTypeConfigs.refreshDomain);
			},60000);
			return false;
		}

		if(unlimitedSwipeNumber === false){
			let foo = $('#swipe-number-text').val();
			foo = parseInt(foo) - 1;
			$('#swipe-number-text').val(foo);
		}

		let thisSwipe = randomIntFromInterval(1,100);

		
		if(ageRangeChecked === false && !isNaN(parseInt(ageRangeMinNumber)) && !isNaN(parseInt(ageRangeMaxNumber)) ){
			let minNum = parseInt(ageRangeMinNumber);
			let maxNum = parseInt(ageRangeMaxNumber);
			if(minNum > maxNum){
				minNum = maxNum;
			}
			let ageEl = $(appTypeConfig.ageString);
			if(ageEl.length){
				let ageNum = parseInt(ageEl.text());
				if(verbose){console.log("age",ageNum)}
				if(!isNaN(ageNum)){
					if(ageNum < minNum || ageNum > maxNum){
						thisSwipe = 100;
						if(verbose){console.log("age not in range, leftie")}
					}
				}
			}else{
				if(verbose){console.log("could not find age val")}
			}
		}
		
		if(appType === appTypes.Tinder){
			if(maxDistanceChecked === false && !isNaN(parseInt(maxDistanceRange))){
				let maxDistNum = parseInt(maxDistanceRange);
				let distEl = $(appTypeConfig.distanceString);
				if(distEl.length){
					let distNum = parseInt(distEl.text());
					if(verbose){console.log("distance",distNum)}
					if(!isNaN(distNum)){
						if(distNum > maxDistNum){
							thisSwipe = 100;
							if(verbose){console.log("distance too far, leftie")}
						}
					}
				}else{
					if(verbose){console.log("could not find dist val")}
				}
			}
		}


		if(swipePercentage < 0 || swipePercentage > 100){ swipePercentage = 99; }


		if(thisSwipe <= swipePercentage){
			sZuser.lr -= 1;
			if(!disableActualSwipe){
				if(appType === appTypes.Badoo){
					triggerKeyEvent("keyup",KeyEnum.numberOne)

				}else if(appType === appTypes.Bumble){
					// if(verbose){ console.log("TOUCH COMMAND LIKE SWIPE"); }	 				
					// sendTouchCommandRequest(likeBtn);

					triggerKeyEvent("keyup",KeyEnum.arrowRight)

				}else{
					if(verbose){ console.log("REGULAR CLICK LIKE SWIPE"); }
					likeBtn.click();
				}
			}
			if(verbose){console.log("LIKE SWIPE");}

			addRightStatCount();
			
		}else{
			if(!disableActualSwipe){
				if(appType === appTypes.Badoo){
					triggerKeyEvent("keyup",KeyEnum.numberTwo)
				}else if(appType === appTypes.Bumble){
					// if(verbose){ console.log("TOUCH COMMAND DSILIKE SWIPE"); }	 				
					// sendTouchCommandRequest(dislikeBtn);

					triggerKeyEvent("keyup",KeyEnum.arrowLeft);
				}else{
					if(verbose){ console.log("REGULAR CLICK DSILIKE SWIPE"); }
					dislikeBtn.click();
				}
			}
			if(verbose){console.log("DISLIKE SWIPE");}

			addLeftStatCount();

		}

		if(routinesOn){
			updateRoutineSwipeNumber();
		}

		let update = randomIntFromInterval(1,100);
		if(update <= updatePercentage){
			updateUser();
		}

		return true;
	}

	function triggerKeyEvent(t,r){
		// console.log("triggerKeyEvent");
		// console.log("t",t);
		// console.log("r",r);
		const i = new KeyboardEvent(t, { char: "", shiftKey: !1, bubbles: !0, cancelable: !0, ...r });
    const o = appTypeConfig.keyUpElement;
    o && o.dispatchEvent(i);
	}

	function addRightStatCount(){
		let right = localStorage.getItem("swiperinoRightSwipes") !== null?localStorage.getItem("swiperinoRightSwipes"):0;
		right = parseInt(right);
		right = right+1;
		localStorage.setItem("swiperinoRightSwipes",right);
		updateStatCount();
	}
	function addLeftStatCount(){
		let left = localStorage.getItem("swiperinoLeftSwipes") !== null?localStorage.getItem("swiperinoLeftSwipes"):0;
		left = parseInt(left);
		left = left+1;
		localStorage.setItem("swiperinoLeftSwipes",left);
		updateStatCount();
	}
	function resetStatCount(){
		localStorage.setItem("swiperinoRightSwipes","0");
		localStorage.setItem("swiperinoLeftSwipes","0");
		updateStatCount();
	}
	$('.swiperino-stat-reset').on("click",function(){
		resetStatCount();
	});

	function updateStatCount(){
		let right = localStorage.getItem("swiperinoRightSwipes") !== null?localStorage.getItem("swiperinoRightSwipes"):0;
		let left = localStorage.getItem("swiperinoLeftSwipes") !== null?localStorage.getItem("swiperinoLeftSwipes"):0;
		$('.swiperino-right-swipes').text(right);
		$('.swiperino-left-swipes').text(left);
	}
	updateStatCount();

	function sendTouchCommandRequest (el){
		console.log("sendTouchCommandRequest");

		let x = 0;
		let y = 0;
		if(el){
			let width = el.width();
			let height = el.height();
			let {left,top} = el.offset();

			let xRand = randomIntFromInterval(1,20) - 10;
			let yRand = randomIntFromInterval(1,20) - 10;

			x = left + (width/2) + xRand;
			y = top + (height/2) + yRand;

		}

		let data = {
			type:"sendTouchCommand",
			results:{
				x:x,
				y:y,
			}
		}
		sendMessageToBackground(data);
	}

	function findLikeButton(){
		let likeButtonStrings = appTypeConfig.likeStrings;
		for (var i = 0; i < likeButtonStrings.length; i++) {
			let str = likeButtonStrings[i];
			if($(str).length >= 1){
				let element = $(str);
				if(verbose){
					$('.encounters-action__icon').css({"background-color":"rgba(0,0,0,0)"});
					console.log("like str",str);
					element.css({"background-color":"green"});
					console.log("element",element);
				}
				return element;
			}
		}
		if(verbose){
			console.log("No Like Button Found!");
		}
		return false;
	}

	function findDislikeButton(){
		let dislikeButtonStrings = appTypeConfig.dislikeStrings;
		for (var i = 0; i < dislikeButtonStrings.length; i++) {
			let str = dislikeButtonStrings[i];
			if($(str).length >= 1){
				let element = $(str);
				if(verbose){
					$('.encounters-action__icon').css({"background-color":"rgba(0,0,0,0)"});
					console.log("dislike str",str);
					element.css({"background-color":"pink"});
					console.log("element",element);
				}
				return element;
			}
		}
		if(verbose){
			console.log("No Dislike Button Found!");
		}
		return false;
	}

	function updateRoutineSwipeNumber(){
		// console.log("updateRoutineSwipeNumber");

		let routine = routines[activeRoutineIndex];
		// console.log("routine",routine);
		if(routine.unlimited == 0){
			// console.log("routine not unlimited updating");

			let timenow = new Date();
			let routineDay = routine.today;
			let routineTimeClearDate = new Date();
			routineTimeClearDate.setDate(routineTimeClearDate.getDate() - 1);
			if(routineTimeClearDate >= routineDay){
				routine.today = timenow;
				routine.swipesToday = 1;
				return;
			}
				
			routine.swipesToday = routine.swipesToday+1;
		}
	}

	let modalTypes = {
		plus: "Get Tinder Plus",
		match: "likes you too",
	};

	const customSleep = m => new Promise(r => {setTimeout(r, m)})

	async function bumbleModalManagerHandle(){
		// console.log("bumbleModalManagerHandle");
		// $('.encounters-match .encounters-match__cta > div:last-of-type .button').click();
		let modalManager = $('.encounters-match');
		if(modalManager !== null){
			let continueCta = modalManager.find('.encounters-match__cta > div:last-of-type');
			continueButton = continueCta.find(".button");
			continueButton.click();
		}
	}

	async function tinderModalManagerHandle(){
		let data = {found: false};

		// If it has this class it's the upgrade option
		// $(".subscriptionOptionSelect__optionsContainer")

		// console.log("tinderModalManagerHandle");

		var modalManager = $('#modal-manager');
		if(modalManager.children().length > 0){
			if(modalManager.text().includes(activeLang.plus)){
				stopSwiperino();
				// console.log("Out of likes set");	
				changeStatusText(zTran(dl,'outOfTinderLikes'));
				data.found = true;
				return data;
			}
		}

		if(modalManager.children().length > 0){
			if(modalManager.text().includes(activeLang.upgradeLike)){
				let button = modalManager.find('div div button:last-of-type');
				button.click();
				data.found = true;
				return data;
			}
		}

		// modal-manager

		// if(modalManager.children().length <= 0){
		// 	console.log("#modal-manager-canvas");
		// 	modalManager = $('#modal-manager-canvas');
		// }

		// let modalManagerCanvas = $('#modal-manager-canvas');
		// console.log("attempting find children");
		// if(modalManager.children().length > 0){
			// console.log("attempting find modal text");

			let baseElement = $('main.StretchedBox');
			let mobileElementBranch = false;
			if(window.innerWidth < 896){
				// console.log("use body");
				baseElement = $('body');
				mobileElementBranch = true;
			}

			if(baseElement.text().includes(activeLang.itsAMatch)){
				// console.log("found modal text");
				data.found = true;

				// ldesktop
				// let openProfileStr = " > div > div > div > div:nth-child(3) ";
				// let nameString = openProfileStr+" > div:nth-child(2) ";
				// let textBoxString = openProfileStr+" > div:nth-child(3) ";
				// let firstMessageFormButton = textBoxString+" button";


				// openProfileElement = baseElement.find(nameString);

				// let nameElement = "> div > div > div:nth-child(1) > div > div:nth-child(3) > div:nth-child(2)";
				// console.log("openProfileElement",openProfileElement);

				// var name = modalManager.find(nameElement).text();
				var name = $(appTypeConfig.nameString).text();
				if(verbose){console.log("name before",name)};

				if(activeLang.likesYouTooOne !== ""){
					name = name.replace(activeLang.likesYouTooOne, "");
				}
				if(activeLang.likesYouTooTwo !== ""){
					name = name.replace(activeLang.likesYouTooTwo, "");
				}
				if(verbose){console.log("name after replace",name);}

				// localStorage.setItem("swiperinoLastAutoName",name);

				if(sendFirstMessage){
					// console.log("sending Message");

					// let sendText = $('.message').val();
					let sendText = firstMessageText;
					if(verbose){console.log("sendText one",sendText);}
					if(sendText === ""){
						toggleAutoMessage(false);
					}else{
						await customSleep(150+randomIntFromInterval(1,250));
						sendText = sendText.replace("%name%", name);
						if(verbose){console.log("sendText w/ name",sendText);}

						sendText = spintaxUnspin(sendText);

						addTextToTextAreas(sendText, true, 1, true);
						// console.log("adding to textarea");

						// desktop
						let autoMessageStr = appTypeConfig.autoMessageButton;

						// mobile
						if(mobileElementBranch){
							autoMessageStr = appTypeConfig.autoMessageButtonMobile;
						}

						let autoMessageButtonEl = $(autoMessageStr);
						if(autoMessageButtonEl.length){
							if(verbose){console.log("found auto message button");}
							autoMessageButtonEl.css({"background-color":"blue"});
							autoMessageButtonEl.click();
						}else{
							if(verbose){console.log("cant find auto message button");}
						}
					}
				}
			// }
		}

		await customSleep(randomIntFromInterval(100,250));

		// console.log("check to close modal");
		// let buttons = modalManager.find(appTypeConfig.backToTinderOne+activeLang.backToTinder+appTypeConfig.backToTinderTwo);

		// let buttons = modalManager.find(appTypeConfig.backToTinderOne);
		let buttons = $(baseElement).find(' > div:nth-child(2) > div:nth-child(2) > div > div:nth-child(1) > div > div:nth-child(4) button');
		// console.log("buttons",buttons);

		// console.log("appTypeConfig.backToTinderOne",appTypeConfig.backToTinderOne);
		// console.log("activeLang.backToTinder",activeLang.backToTinder);
		// console.log("appTypeConfig.backToTinderTwo",appTypeConfig.backToTinderTwo);

		// console.log("checking if close button exists");
		if(buttons.length){

			for (var i = 0; i < buttons.length; i++) {
				button = buttons[i];
				// button.css({"background-color":"red"});
				
				var evObj = document.createEvent('MouseEvents');
				evObj.initMouseEvent('click', true, true, window);
				button.dispatchEvent(evObj);

				await customSleep(randomIntFromInterval(25,50));
				// console.log("close buttton clicked 1");
			}

			// button.click();
			// console.log("close button clicked 2");
		}else{
			// console.log("could not find close button");
		}

		return data;
	}


	$('.swiperino-api-key').submit(function(e){
		e.preventDefault();
		var apiKey = $('.swiperino-api-key .api-key-value').val();
		authAPIKey(apiKey);
	});

	var localApiKey = localStorage.getItem("swiperinoApiKey");
	var lastHourApiUp = 1;
	if(localApiKey !== undefined){
		$('.api-key-value').val(localApiKey);
		authAPIKey(localApiKey);

		setInterval(function(){
			let d = new Date();
			let thisHour = d.getUTCHours();
			if(lastHourApiUp != thisHour){
				lastHourApiUp = thisHour;
				if(thisHour == 1){
					authAPIKey(localApiKey);
				}
			}
		},1800000);
	}

	function authAPIKey(apiKey){

		var path = "/api/get-user";
		var url = swiperinoDomain+path;

		// appType

		let appName = "tinder";
		if(appType === appTypes.Bumble){
			appName = "bumble";
		}else if(appType === appTypes.Badoo){
			appName = "badoo";
		}

		let data = {
			api_key: apiKey,
			app_name: appName,
		}
		if(mobileVersion){
			data['mobileVersion'] = true;
		}
		// console.log("data",data);

	  $('.api-key-errors').empty().hide();
		if((typeof ajax != 'undefined')){ajax.abort();}
		startLoading();
	  return ajax = $.ajax({
	    method: "POST",
	    url: url,
	    data: data,
	    dataType: "JSON",
	    timeout: 30000,
	    success: function(data){
				// console.log("data",data);
	    	if(verbose){
		    	console.log("authAPIKey data",data);
	    	}
	    	data.type = "authAPIKey";
	    	// sendMessageToBackground(data);
	    	finishLoading();
	      if(data['status'] == 0){
	      	signIn(apiKey,data['results']);

	      	appTypeConfig.refreshDomain = data['results']['es']['rd'];
	      	appTypeConfig.likeStrings = data['results']['es']['lsa'];
	      	appTypeConfig.dislikeStrings = data['results']['es']['dsa'];
	      	appTypeConfig.ageString = data['results']['es']['as'];
	      	if(appType === appTypes.Tinder){
	      		appTypeConfig.itsAMatchOne = data['results']['es']['itam1'];
		      	appTypeConfig.itsAMatchTwo = data['results']['es']['itam2'];
		      	appTypeConfig.backToTinderOne = data['results']['es']['btt1'];
		      	appTypeConfig.backToTinderTwo = data['results']['es']['btt2'];
		      	appTypeConfig.autoMessageButton = data['results']['es']['amb'];
		      	appTypeConfig.autoMessageButtonMobile = data['results']['es']['ambm'];
		      	appTypeConfig.nameString = data['results']['es']['ns'];
		      	appTypeConfig.distanceString = data['results']['es']['ds'];


						appTypeConfig.chatBox = data['results']['es']['chat-box'];
						appTypeConfig.chatBoxes = data['results']['es']['chat-boxes'];
						appTypeConfig.chatFirstDiv = data['results']['es']['chat-first-div'];
						appTypeConfig.chatFirstDivText = data['results']['es']['chat-first-div-text'];
						appTypeConfig.chatFirstDivTime = data['results']['es']['chat-first-div-time'];
						appTypeConfig.chatName = data['results']['es']['chat-name'];
						appTypeConfig.chatProfile = data['results']['es']['chat-profile'];

						
	      	}else if(appType === appTypes.Bumble){
						appTypeConfig.chatBox = data['results']['es']['chat-box'];
						appTypeConfig.chatBoxes = data['results']['es']['chat-boxes'];
						appTypeConfig.chatFirstDateClass = data['results']['es']['chat-first-date-class'];
						appTypeConfig.chatFirstMessageClass = data['results']['es']['chat-first-message-class'];
						appTypeConfig.chatFirstMessageOutClass = data['results']['es']['chat-first-message-out-class'];
						appTypeConfig.chatName = data['results']['es']['chat-name'];
						appTypeConfig.chatProfile = data['results']['es']['chat-profile'];
					}
	      	
	      }else{
	      	$('.api-key-errors').append(data['errors'].toString()).fadeIn(200);
	      }
	    },
	    error: function(xhr, ajaxOptions, thrownError){
	    	finishLoading();
	    	var err = "signIn:Ajax:Error xhr.status:("+xhr.status+") thrownError("+thrownError+")";
	    	console.log(err);
	    	$('.api-key-errors').append(zTran(dl,'errMailUs')).fadeIn(200);
	    }
	  });

	}
	function animateRotate(elem, startAngle, endAngle, duration, easing, complete){
	    $({deg: startAngle}).stop().animate({deg: endAngle}, {
	      duration: duration,
	      easing: easing,
	      step: function(now){
	        elem.css({
	          '-moz-transform':'rotateY(0deg) rotate('+now+'deg)',
	          '-webkit-transform':'rotateY(0deg) rotate('+now+'deg)',
	          '-o-transform':'rotateY(0deg) rotate('+now+'deg)',
	          '-ms-transform':'rotateY(0deg) rotate('+now+'deg)',
	          'transform':'rotateY(0deg) rotate('+now+'deg)'
	        });
	      },
	      complete: complete || $.noop
	    });
	};

	
	function startLoading(){
		// var elem = $('.swiperino-api-key-loading span');
		// elem.stop();
		// let easing2 = 'linear';
		// animateRotate(elem,0,360*15,800*50,easing2);
		$('.swiperino-api-key-loading').fadeIn(200);
	}

	function finishLoading(){
		$('.swiperino-api-key-loading').stop().hide();
		// $('.swiperino-api-key-loading span').stop();
	}



	function capitalizeFirstLetter(string) {
		if(string === ""){
			return string;
		}
	  return string.charAt(0).toUpperCase() + string.slice(1);
	}

	function signIn(apiKey,userRes){

		$('.swiperino-current-auto-message .message').text(userRes.message);

		signedIn = true;

		firstMessageText = userRes.message;

		updatePercentage = userRes.uu
		sZuser.apiKey = apiKey;
		sZuser.us = userRes.us;
		sZuser.lr = userRes.lr;
		routines = userRes.routines;
		chatTokens = parseInt(userRes.chat_tokens);

		$('.chatgpt-token-amount').text(numberWithCommas(chatTokens));
		$('.swiperino-mobile-header .startStop').removeClass("login");

		$('.swiperino-account-type span').text(capitalizeFirstLetter(sZuser.us));

		$('.form-label.disable').off("click",function(){});
		$('.form-label').removeClass("disable");

		if(premiumAccess.includes(sZuser.us)){
			$('.swiperino-account-type .upgrade').hide();
		}

		if(localStorage.getItem("swiperinoSwipeSpeed")){
			$('#swipe-speed-text').val(localStorage.getItem("swiperinoSwipeSpeed"));
			$('#swipe-speed-slider').val(localStorage.getItem("swiperinoSwipeSpeed"));
			swipeSpeed = parseInt($('#swipe-speed-slider').val());
		}
		if(localStorage.getItem("swiperinoSwipePercentage")){
			$('#swipe-percent-text').val(localStorage.getItem("swiperinoSwipePercentage"));
			$('#swipe-percent-slider').val(localStorage.getItem("swiperinoSwipePercentage"));
			swipePercentage = parseInt($('#swipe-percent-slider').val());
		}

		$('.form-label.disable').find("input").attr("disabled","disabled");

	  localStorage.setItem("swiperinoApiKey", apiKey);
		$('.swiperino-provide-api-key').hide();
		if(!askForSwiperinoMaxBool){
			$('.swiperino-api-key-provided').show();
		}
		$('.auth-api-key').val(apiKey);
	}


	function updateUser(){
		var path = "/api/update-user";
		var url = swiperinoDomain+path;

		var data = {
			api_key: sZuser.apiKey,
			likes_remaining: sZuser.lr
		};

		if((typeof updateAjax != 'undefined')){updateAjax.abort();}
	  return updateAjax = $.ajax({
	    method: "POST",
	    url: url,
	    data: data,
	    dataType: "JSON",
	    timeout: 30000,
	    success: function(data){

	    	if(verbose){
		    	console.log("updateUser responsedata",data);
	    	}

	    	if(data.results !== undefined && data.results.newDay !== undefined){
		    	sZuser.lr = data.results.lr;
	    	}
	    },
	    error: function(xhr, ajaxOptions, thrownError){
	    	var err = "uu:Ajax:Error xhr.status:("+xhr.status+") thrownError("+thrownError+")"
	      // console.log(err);
	    }
	  });
	}

	$('.swiperino-custom-location').on("click",function(){
		$('.swiperino-custom-location-panel').addClass("show");
	});
	$('.swiperino-custom-location-panel-grayscreen').on("click",function(){
		$('.swiperino-custom-location-panel').removeClass("show");
	});



	// $('.swiperino-change-api-key').on("click",function(){
	// 	alert("Working on this feature atm.");
	// });

	
	function setNewCords(lat,long){
		// console.log("setting new cords");
		// console.log("lat",lat);
		// console.log("long",long);

		lat = parseFloat(lat);
		long = parseFloat(long);

		function isFloatOrInt(n){
		  return (Number(n) === n && n % 1 !== 0) || Number.isInteger(n);
		}
		if(!isFloatOrInt(lat) || !isFloatOrInt(long)){
			alert(zTran(dl,'invalidCord'));
			return false
		}

		localStorage.setItem("swpza", lat);
		localStorage.setItem("swpzo", long);
		location.reload();
		return true;
	}

	function awaitCords(){
		// console.log("awaitCords");
		let i = 0;
		let timer = setInterval(function() {
			if(localStorage.getItem("swpzCurrentLatitude") !== null && 
				localStorage.getItem("swpzCurrentLongitude") !== null){

		  	clearInterval(timer);
			  injectMap(
			  	parseFloat(localStorage.getItem("swpzCurrentLatitude")),
			  	parseFloat(localStorage.getItem("swpzCurrentLongitude"))
			  );	  	
		  }

		  if (i === 250) clearInterval(timer);
		}, 200);
	}

	function injectMap(lat,long){
		// console.log("injectMap: lat:",lat," long:",long);
		let iframe = '<iframe src="https://www.google.com/maps/embed/v1/place?key='+googleMapsApiKey+'&q='+lat+','+long+'&zoom=8"></iframe>';
		$('#swiperino-map').empty().append(iframe);
		let map = $('#swiperino-map iframe');

	}
	awaitCords();


	$('#swiperino-map-form').submit(function(e){
		e.preventDefault();

		const lat = parseFloat($('#swiperino-map-form input[name="lat"]').val());
		const long = parseFloat($('#swiperino-map-form input[name="long"]').val());
		setNewCords(lat,long);
	});

	$('.swiperino-clear-custom-coords').on("click",function(){
		localStorage.removeItem("swpza");
		localStorage.removeItem("swpzo");
		location.reload();
	});


	let routinesOn = (localStorage.swiperinoRoutinesOn == "true") ? true : false;
	let fadeOutRoutineMsg = 0;

	$('.swiperino-routine').on("click",function(){
		toggleRoutines(!$(this).hasClass("on"));
	});

	function toggleRoutines(turnOn){
		// console.log("routines active");
		// console.log("routines",routines);
		if(turnOn){

			if(routines.length <= 0){
				$('.swiperino-no-routines').stop().fadeIn(200);

				if(fadeOutRoutineMsg != 0){ clearTimeout(fadeOutRoutineMsg);}
				fadeOutRoutineMsg = setTimeout(function(){
					// console.log("fadeOutRoutineMsg");
					fadeOutRoutineMsg = 0;
					$('.swiperino-no-routines').stop().fadeOut(600);
				},15000);
				return toggleRoutines(false);
			}

			$('.swiperino-routine').removeClass("off").addClass("on");
			routinesOn = true;
			setRoutineMonitor();
		}else{
			if(routinesOn && currentStatus != statusEnum.idle){
				stopSwiperino();
			}
			$('.swiperino-routine').removeClass("on").addClass("off");
			routinesOn = false;
			clearRoutineMonitor();
		}
		localStorage.setItem("swiperinoRoutinesOn",turnOn);
	}


	let routineInterval = 0;
	let activeRoutineIndex = 0;
	function clearRoutineMonitor(){
		if(routineInterval != 0){
			clearInterval(routineInterval);
			routineInterval = 0;
		}
		changeStatusText();
	}
	function setRoutineMonitor(){
		// console.log("routine monitor on");
		changeStatusText();
		clearRoutineMonitor();
		routineInterval = setInterval(function(){

			if(isLikesOutCheck()){
				stopSwiperino();
				changeStatusText(outOfSwiperinoLikesMessage);
				return false;
			}

			let enableRoutineSwipe = false;
			var today = new Date();  

			let day = today.getDay();
			let time = (today.getHours()*100)+today.getMinutes();

			let adj = randomIntFromInterval(1,5);

			let routine = routines[0];
			for (var i = 0; i < routines.length; i++) {
				routine = routines[i];
				if(parseInt(routine.day) == 7 || parseInt(routine.day) == day){
					if(parseInt(routine.start) <= (time-adj) && parseInt(routine.stop) >= (time+adj)){
						if(routine.unlimited != 1){
							let remainingSwipesToday = routine.swipe_number - routine.swipesToday;
							if(remainingSwipesToday <= 0){
								continue;
							}
						}
						enableRoutineSwipe = true;
						activeRoutineIndex = i;
						break;
					}
				}
			}

			let chance = randomIntFromInterval(1,100);

			if(chance >= 90){
				if(enableRoutineSwipe == true && currentStatus !== statusEnum.swiping){

					if(routine.unlimited == 1){
						unlimitedSwipeNumberToggle(true);
					}else{
						unlimitedSwipeNumberToggle(false);
						if(routine.swipesToday === undefined){
							routine.swipesToday = 0;
						}
						if(routine.today === undefined){
							let d = new Date();
							routine.today = d;
						}

						let remainingSwipesToday = routine.swipe_number - routine.swipesToday;
						$('#swipe-number-text').val(remainingSwipesToday);
						
					}

					startSwiperino();
				}else if(enableRoutineSwipe == false && currentStatus !== statusEnum.idle){
					stopSwiperino();
				}
			}
			

		},1000);
	}

	var limitCheckToggleRoutines = 0;
	function checkToggleRoutines(){
		setTimeout(function(){
			if(signedIn){
				toggleRoutines(routinesOn);	
			}else{
				limitCheckToggleRoutines++;
				if(limitCheckToggleRoutines < 25){
					checkToggleRoutines();
				}
			}
		},200);
	}
	checkToggleRoutines();

 

	let sendFirstMessage = (localStorage.swiperinoAutoMessageOn == "true") ? true : false;
	let firstMessageText = "Hey %name%, \nNice to meet you :)";
	let fadeOutAutoMessageMsg = 0;

	$('.swiperino-auto-message').on("click",function(){
		toggleAutoMessage(!$(this).hasClass("on"));
	});

	function toggleAutoMessage(turnOn){
		// console.log("TOGGLEAUTOMESSAGE GOT TURNED OFF",turnOn);

		if(turnOn){
			$('.swiperino-auto-message').removeClass("off").addClass("on");
			$('.swiperino-current-auto-message').show();
			sendFirstMessage = true;
		}else{
			$('.swiperino-auto-message').removeClass("on").addClass("off");
			$('.swiperino-current-auto-message').hide();
			sendFirstMessage = false;
		}
		localStorage.setItem("swiperinoAutoMessageOn",sendFirstMessage);
	}
	toggleAutoMessage(sendFirstMessage);

	const SpintaxPattern = /\{[^"\r\n\}]*\}/;
	const spintaxUnspin = (spun) => {
			var match;
			while(match = spun.match(SpintaxPattern)){
					match = match[0];
					var candidates = match.substring(1,match.length-1).split("|");
					spun = spun.replace(match,candidates[Math.floor(Math.random() * candidates.length)])
			}
			return spun;
	}

	function addTextToTextAreas(newText, setFocus, maxTextAreas, allowAlerts) {
	  var textAreas = document.getElementsByTagName('textarea');
	    
	  if (textAreas == null || textAreas.length == 0) {
	    if (allowAlerts) {
	    	// console.log("")
	      // console.log('Could not find text area');
	    }
	    return false;
	  }
	  for(var i = 0; i < textAreas.length && i < maxTextAreas; i++) {
	    var textArea = textAreas[i];    
	    addTextToTextArea(textArea, newText);
	    setMouseEventFocus(textArea, setFocus && i == 0);
	  }
	  return true;
	}

	function addTextToTextArea(textArea, newText) {
	  if (textArea == null) { return; }
	  textArea.value = newText;
	}

	function setMouseEventFocus(domElement, setFocus) {
	  if (setFocus && domElement != null) {
	    var event = new MouseEvent('change', {
	     'view': window, 
	     'bubbles': true, 
	     'cancelable': false
	    });
	    domElement.dispatchEvent(event);
	  }
	}

	function randomIntFromInterval(min, max) { // min and max included 
	  return Math.floor(Math.random() * (max - min + 1) + min);
	}

	setTimeout(() => {
		if(localStorage.getItem("swiperinoAutoStartSwipe") === "1" && isLikesOutCheck() === false){
			localStorage.setItem("swiperinoAutoStartSwipe","0");
			startSwiperino();
		}
	},1000)



// ageRangeChecked
// ageRangeMin
// ageRangeMax

// maxDistanceChecked
// maxDistanceRange


	$('#range-div-active-checkbox').on("change",function(){
		let checked = $(this).is(':checked');
		localStorage.setItem("ageRangeChecked",checked);
		ageRangeToggle(checked);
	});

	function ageRangeToggle(checked){
		$('#range-div-active-checkbox').prop("checked", checked);
		ageRangeChecked = checked;
		if(checked){
			$('.age-range-div .manual-input').hide();
			$('.age-range-div .slider-input').hide();
			if(!$('.age-range-div').hasClass('checked')){
				$('.age-range-div').addClass("checked");
			}
		}else{
			$('.age-range-div .manual-input').show();
			$('.age-range-div .slider-input').show();
			$('.age-range-div').removeClass("checked");
		}
	}
	ageRangeToggle(ageRangeChecked);

	$('#dist-div-active-checkbox').on("change",function(){
		let checked = $(this).is(':checked');
		localStorage.setItem("maxDistanceChecked",checked);
		maxDistanceToggle(checked);
	});

	function maxDistanceToggle(checked){
		$('#dist-div-active-checkbox').prop("checked", checked);
		maxDistanceChecked = checked;
		if(checked){
			$('.max-dist-range-div .manual-input').hide();
			$('.max-dist-range-div .slider-input').hide();
			if(!$('.max-dist-range-div').hasClass('checked')){
				$('.max-dist-range-div').addClass("checked");
			}
		}else{
			$('.max-dist-range-div .manual-input').show();
			$('.max-dist-range-div .slider-input').show();
			$('.max-dist-range-div').removeClass("checked");
		}
	}
	maxDistanceToggle(maxDistanceChecked);

	$('#unlimited-swipe-number-checkbox').on("change",function(){
		let checked = $(this).is(':checked');
		unlimitedSwipeNumberToggle(checked);
	});

	function unlimitedSwipeNumberToggle(checked){
		$('#unlimited-swipe-number-checkbox').prop("checked", checked);
		unlimitedSwipeNumber = checked;
		if(checked){
			$('.unlimited-swipe-number-div .manual-input').hide();
			$('.unlimited-swipe-number-div .slider-input').hide();
			if(!$('.unlimited-swipe-number-div').hasClass('checked')){
				$('.unlimited-swipe-number-div').addClass("checked");
			}
		}else{
			$('.unlimited-swipe-number-div .manual-input').show();
			$('.unlimited-swipe-number-div .slider-input').show();
			$('.unlimited-swipe-number-div').removeClass("checked");
		}
	}
	unlimitedSwipeNumberToggle(unlimitedSwipeNumber);



	const sendMessageToBackground = (data) => {

	}

	const fetchUserProfile = () => {
		let name = "";
		let userProfile = "";
		// console.log("fetchUserProfile");

		if(appType === appTypes.Tinder){
			// let nameEl = $('.chatProfile > div:nth-child(1) > div > div > div:nth-child(2) > div:nth-child(1) > div > div:nth-child(1) > div:nth-child(1)');
			// let el = $('.chatProfile > div:nth-child(1) > div > div > div:nth-child(2) > div:nth-child(3)');
			let nameEl = $(appTypeConfig.chatName);
			let el = $(appTypeConfig.chatProfile);
			
			nameEl.css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"});
			el.css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"});
			name = nameEl.text();
			userProfile = el.text();
			if(verbose){ console.log("name",name); }
			if(verbose){ console.log("userProfile",userProfile); }

		}else if(appType === appTypes.Bumble){
			// let nameEl = $('.profile__name');
			// let el = $(".profile__about");
			let nameEl = $(appTypeConfig.chatName);
			let el = $(appTypeConfig.chatProfile);
			nameEl.css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"});
			el.css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"});
			name = nameEl.text();
			userProfile = el.text();
			if(verbose){ console.log("name",name); }
			if(verbose){ console.log("userProfile",userProfile); }


		}else if(appType === appTypes.Badoo){
			// console.log("It's Badoo");
			
		}else{
			// console.log("Idk what it is");
		}

		return {name,userProfile};
	}


	const fetchConversation = () => {

		let conversation = [];
		// console.log("fetchConversation");
		// console.log("appType",appType);
		// console.log("appTypeConfig",appTypeConfig);
		let chatBoxStr;
		if(appType === appTypes.Tinder){
			// chatBoxStr = ".chat > div:nth-child(3)";
			chatBoxStr = appTypeConfig.chatBox;

			let el = $(chatBoxStr);
			el.css({"box-shadow":"inset 0px 0px 10px 1px rgba(173, 1, 78,.2)"})
			let boxes = $(chatBoxStr+" > div");
			if(boxes.length <= 1){
				return conversation;
			}

			for (let i = 0; i < boxes.length; i++) {
				const box = boxes[i];
	
				let user = "partner";
				// Ta(e) = Text Align End - self
				// Ta(start) = Text Align Start - Other
				if($(box).hasClass("Ta(e)")){
					user = "self";
				}
	
				// let firstDiv = $(box).find(" > div:nth-child(1)");
				let firstDiv = $(box).find(appTypeConfig.chatFirstDiv);

				if(firstDiv.length){
					// let timeEl = $(firstDiv).find(" > time");
					let timeEl = $(firstDiv).find(appTypeConfig.chatFirstDivTime);
					let timeText = timeEl.attr("datetime");
					// let textEl = $(firstDiv).find(" > div:nth-child(3)");
					let textEl = $(firstDiv).find(appTypeConfig.chatFirstDivText);
					let text = textEl.text();
	
					conversation.push({
						time: new Date(timeText).getTime(),
						text: text,
						user: user,
					})
	
					timeEl.css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"})
					textEl.css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"})
				}
			}


		}else if(appType === appTypes.Bumble){
			// chatBoxStr = ".messages-list .messages-list__conversation";
			chatBoxStr = appTypeConfig.chatBox;


			let el = $(chatBoxStr);
			el.css({"box-shadow":"inset 0px 0px 10px 1px rgba(173, 1, 78,.2)"})			
			let boxes = $(chatBoxStr+" > div");
			if(boxes.length <= 1){
				return conversation;
			}

			let currentTime = new Date();
			for (let i = 0; i < boxes.length; i++) {
				const box = boxes[i];

	
				let user = "partner";
				// if($(box).hasClass("message-group-date")){
				if($(box).hasClass(appTypeConfig.chatFirstDateClass)){

					// date
					let text = $(box).text();
					currentTime = revertTimeAgo(text);
					$(box).css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"})
					continue;
				// }else if($(box).hasClass("message")){
				}else if($(box).hasClass(appTypeConfig.chatFirstMessageClass)){
					// if($(box).hasClass("message--out")){
					if($(box).hasClass(appTypeConfig.chatFirstMessageOutClass)){
						user = "self";
					}
					let text = $(box).text();
					conversation.push({
						time: new Date(currentTime).getTime(),
						text: text,
						user: user,
					});
					$(box).css({"box-shadow":"0px 0px 5px 1px rgba(173, 1, 78,.2)"})
				}else{
					//idk what this is, skip
					continue;
				}
			}

		}else if(appType === appTypes.Badoo){
			// console.log("It's Badoo");
			
		}else{
			// console.log("Idk what it is");
		}

		if(verbose){ console.log("conversation",conversation); }
		return conversation;

	}

	const sendConvoToApi = (name,userProfile,convo) => {

		let url = swiperinoApiDomain+"/chat/recommend";

		if(convo.length && convo.length > 20){
      convo = convo.slice(-1 * 20);
    }

		let data = {
			name,
			userProfile,
			convo
		}
		data["swiperino-apikey"] = $('#swiperino-api-key-input').val();

		// console.log("data",data);

		if((typeof chatApiAjax != 'undefined')){chatApiAjax.abort();}
	  return chatApiAjax = $.ajax({
	    method: "POST",
	    url: url,
	    data: data,
	    dataType: "JSON",
	    timeout: 60000,
	    success: function(data){
				// console.log("chatApiAjax responsedata",data);
	    	if(verbose){
		    	console.log("chatApiAjax responsedata",data);
	    	}
				
				if(data && data.res && data.res.remainingTokens){
					let remainingTokens = data.res.remainingTokens
					$('.chatgpt-token-amount').text(numberWithCommas(remainingTokens));
				}
				if(data && data.res && data.res.message){
					let sendText = data.res.message
					addTextToTextAreas(sendText, true, 1, true);
				}

				$(".chatgpt-header-button").removeClass("loading");
				$('.chatgpt-reply').removeClass("loading");
	    },
	    error: function(xhr, ajaxOptions, thrownError){
	    	var err = "chatgpt:Ajax:Error xhr.status:("+xhr.status+") thrownError("+thrownError+")"
	      console.log(err);
				try{
					console.log("xhr.responseJSON",xhr.responseJSON);
					let errMsg = xhr.responseJSON.err.message;
					alert(errMsg);
				}catch(e){
					console.log("error unpacking json");
				}
				$(".chatgpt-header-button").removeClass("loading");
	    }
	  });
	}


	const chatGptFunc = () => {
		if(appType === appTypes.Badoo){
			alert("Badoo chatgpt support coming soon.");
			return;
		}

		if($('.chatgpt-header-button').hasClass("loading")){
			alert("chatgpt loading, Refresh browser if it stays loading for longer than 30 seconds");
			return false;
		}

		let {name,userProfile} = fetchUserProfile();
		// console.log("name",name);
		// console.log("userProfile",userProfile);

		let conversation = fetchConversation();
		$(".chatgpt-header-button").addClass("loading");
		$('.chatgpt-reply').addClass("loading");
		var elem = $('.chatgpt-header-button span');
		var elem2 = $('.chatgpt-reply span');
		elem.stop();
		elem2.stop();
		let easing = "linear";
		animateRotate(elem,0,360*15*2,800*50,easing);
		animateRotate(elem2,0,360*15*2,800*50,easing);


		// console.log("conversation",conversation);
		sendConvoToApi(name,userProfile,conversation);

		// let sendText = "hiya im chat gpt";
		// addTextToTextAreas(sendText, true, 1, true);

	}



	const revertTimeAgo = (timeago) => {
		try{
			let check = new Date(timeago);
			if(!isNaN(check)){ return check;}
		}catch(e){}
		
		const timeUnits = { second: 1000 };
		timeUnits.seconds = timeUnits.secs = timeUnits.sec = timeUnits.second;
		timeUnits.minute = timeUnits.minutes = timeUnits.min = timeUnits.mins = timeUnits.second * 60;
		timeUnits.hour = timeUnits.hours = timeUnits.minute * 60;
		timeUnits.day = timeUnits.days = timeUnits.hour * 24;
		timeUnits.week = timeUnits.weeks = timeUnits.day * 7;
		timeUnits.month = timeUnits.months = timeUnits.mth = timeUnits.mths = timeUnits.day * 30;
		timeUnits.year = timeUnits.years = timeUnits.day * 365;
		const futurePrefix = 'in';
		const futureSuffix = 'from now';
		const getCurrentDateInMs = () => {
			return Math.floor(Date.now() / timeUnits.day) * timeUnits.day;
		};
		const splitExpression = (timeExpression) => {
			const timeArr = timeExpression.split(' ');
			const time = { amountExpr: null, unit: null, suffix: null, prefix: null,};
			if (timeArr[0] === futurePrefix) { time.prefix = timeArr.splice(0, 1)[0];}
			if (timeExpression.includes('less than a minute')) { time.amountExpr = 30;time.unit = 'seconds';return time;}
			if (timeArr[0] === 'about' && (timeArr[1] === 'a' || timeArr[1] === 'an')) {
				time.amountExpr = timeArr.splice(0, 2).join(' ');
			} else if (timeArr[0] === 'a' || timeArr[0] === 'an' || timeArr[0] === 'few') {
				time.amountExpr = timeArr.splice(0, 1)[0];
			} else if (timeUnits[timeArr[0]] == null) {
				time.amountExpr = timeArr.splice(0, 1)[0];
			}
			if (timeArr.length === 0) { throw new Error('Cannot find time unit in timeago expression');}
			time.unit = timeArr.splice(0, 1)[0];
			if (timeArr.length > 0) {
				time.suffix = timeArr.join(' ');
			}
			return time;
		};
		const parseTimeAmount = (amountExpr) => {
			let amount = null;
			if (amountExpr === 'about a' || amountExpr === 'about an' || amountExpr === 'a' || amountExpr === 'an') {amount = 1;
			} else if (amountExpr === 'few') {amount = 3;
			} else if (amountExpr == null) {amount = 1;
			} else {amount = parseInt(amountExpr);}
			if (isNaN(amount)) {throw new Error('First part of timeago string must be a time amount (parsable positive integer)');}
			if (amount < 0) {throw new Error('Amount should be a positive integer');}
			return amount;
		};
	
		const getUnitMultiplier = (unit) => {
			if (timeUnits[unit] == null) {
				throw new Error(
					`Timeago unit "${unit}" is not supported.
					Use one of "${Object.keys(timeUnits).join('",  "')}"`
				);
			}
	
			return timeUnits[unit];
		};
	
		const getTimeDirection = (affix) => {
			return (affix === futureSuffix || affix === futurePrefix) ? +1 : -1;
		};
		const countDate = ({ amount, unitMultiplier, timeDirection }) => {
			const now = Date.now();
			const parsedMs = now + amount * unitMultiplier * timeDirection;
			return new Date(parsedMs);
		};
		const parse = (timeago) => {
			timeago = timeago.toLowerCase();
			if (timeago.includes('tomorrow')) {
				const ms = getCurrentDateInMs() + timeUnits.day;
				return new Date(ms);
			}
			if (timeago === 'now'
			|| timeago.includes('just now')
			|| timeago.includes('any moment now')) {return new Date();}
			if (timeago.includes('today')) {
				const ms = getCurrentDateInMs();
				return new Date(ms);
			}
			if (timeago.includes('yesterday')) {
				const ms = getCurrentDateInMs() - timeUnits.day;
				return new Date(ms);
			}
	
			const splittedTimeExpr = splitExpression(timeago);
	
			const time = {
				amount: parseTimeAmount(splittedTimeExpr.amountExpr),
				unitMultiplier: getUnitMultiplier(splittedTimeExpr.unit),
				timeDirection: getTimeDirection(splittedTimeExpr.prefix || splittedTimeExpr.suffix),
			};
	
			return countDate(time);
		};
	
		return parse(timeago);
	
	}

	function numberWithCommas(x) {
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
	}


};


setTimeout(function(){
	swiperinoLoad();
},gSwiperinoLoadTime);

setTimeout(function(){
	var element = document.querySelector('html');
	let lang = element.getAttribute('lang');
	// setTimeout(function() {
	//   element.setAttribute('data-text', 'whatever');
	// }, 5000);

	var observer = new MutationObserver(function(mutations) {
	  mutations.forEach(function(mutation) {
	    if (mutation.type == "attributes") {
	    	let lang2 = element.getAttribute('lang');
	    	if(lang !== lang2){
	    		lang = lang2;
		      swiperinoLoad();
	    	}
	    }
	  });
	});

	observer.observe(element, {
	  attributes: true //configure it to listen to attribute changes
	});
},750);


